/* (c) Joerg Schulenburg Jun 2000

 this is part of spin-package

 it is for division of matrix multiplication 
 in parallelizable block matrix multiplication
 
    b = H * a    (a,b vectors, H matrix)
    
    b[i] = sum_j H[i,j] * a[j]
    
 blocks can be multiplicated step by step on one system or
 they can be multiplicated on different processors/systems
 
 but you have to pay additional network/harddisk traffic
 
 if b_num is one you have only one block (similar to old version)


 */

#ifndef _HBLOCK_H
#define _HBLOCK_H

#include "config.h"

#ifndef B_NL2
#define B_NL2 2		/* ln2 num of blocks, defined in config.h! 0..8 */
#endif
#define B_NUM (1<<B_NL2)	/* num of blocks, 2^B_NL2 */

/* #include "defs.h" */

extern unsigned long b_ofs[B_NUM];	/* start index 0..n1-1 of block */
extern unsigned long b_len[B_NUM];	/* block len */
extern unsigned long b_hnz[B_NUM];	/* block entries */
extern unsigned long b_snz[B_NUM];	/* stored block entries */
extern unsigned long b_sn1[B_NUM];	/* stored block lines */
extern int b_bits;			/* b_len[0..n-2]=1l<<b_bits */
extern unsigned long b_mask;			/* ~((~0)<<b_bits) */

/* calculate blocknumber (0..B_NUM-1) from idx (0..n1-1) */
int b_getnum(unsigned long idx);

/* initialization, n1 is whole matrix size */
int b_ini(unsigned long n1,int vvv);

#include "h_file.h"
#define HBLen (256) /* 1...256 single-byte-gzread is very slow! */
extern struct thxy b_hbuf[B_NUM][HBLen]; /* buffer for faster access */ 
extern struct thxy *b_hbp[B_NUM];  /* puffer-pointer */      
extern unsigned long b_hbl[B_NUM]; /* num valid data in buffer bufh */  
#endif
