
    
/* --- --- Berechnung des kleinsten EW mit Lanczos (Gagliano) ---------- */
/* --- Inp: iv  Out: v0,itr,ew  Wrk: v1 */
int lanz1(tvec *v0,tvec *v1,tvec *ev);
      
/* ----------- bisection methode -------------------------------------
 * --- Inp: ta,tb=Tridiagonalmatrix(TM),  nn=dimension der matrix  ---
 * ---      ne=anzahl zu berechnender ew, ep=genauigkeit           ---
 * --- Out: ew  Eigenwerte der TM ueber Nullstellen von Det(A-x*I) --- */
/* --- was passiert bei Entartung? => EW nur einfach! --- */
/* void bisec(int nn,int ne,zahl ep); */

/* --- EVs einer Tridiagonalen Matrix mit inverser Iteration */
/* --- nn i Matrixgroesse, {ta,tb} TriDiagMatrix -> tc EVs */
/* --- fuer Entartung muss EW in ew[] 2mal enthalten sein! */
/* void vec12(int nn,int nev); */

/* int konvergenz(zahl *ew,zahl *et,zahl eps);*/ 	/* from inc1() */

/* --- --- Berechnung der kleinsten EW mit Lanczos --------------------- */
/* --- Inp: iv  Out: a,b,itr,ew  Wrk: v0,v1 ret: Iterationen */
int inc1(int nev,tvec *v0,tvec *v1);
    
/* --- eigenvector by the Lanczos method 
 * --- Inp: a,b,c --- Out: v0,v1,ev */
void incv1(int nev,tvec *v0,tvec *v1,tvec ev[],int itr);

/* --- --- Berechnung des kleinsten EW mit special-Lanczos 2x2 matrix --- 
 * --- Inp: iv,v0=startvektor  Out: itr,ew,v0=eigenvektor  ---------- */
int lanz2(tvec *v0);	/* return number of iterations done */
    
/* -------------------------- Diag mit Jacobi ----------------------------------- */
void jacobi2(double a[], int n, double d[], double v[], int *nrot);
