#include "defs.h"
#include "block.h"
#include "array_m.h"
#include "vector.h"
#include "spins.h"
#ifdef CONFIG_PTHREAD
#include <pthread.h>
#endif

void mltply_av(double r, tvec *v0){  /* v0*=r */
  int blk; ULong i;
  for(blk=0;blk<B_NUM;blk++)
  for(i=0l;i<b_len[blk];i++) 
    v0->v[blk][i]=M_d2f(M_f2d(v0->v[blk][i])*r);
}

void clrvec(tvec *v){int j;ULong i;
  for(j=0;j<B_NUM;j++)for(i=0l;i<b_len[j];i++)v->v[j][i]=M_d2f(0);
  return;
}

double normvec(tvec *v){
    double r=0.0;ULong j;int i;
    for(i=0;i<B_NUM;i++)for(j=0l;j<b_len[i];j++)r+=Norm(M_f2d(v->v[i][j]));
    if(r<=1e-20){if(vvv&4)printf(" norm_vec<1e-20");} else
    if(r!=1.0){r=1.0/sqrt(r);
      for(i=0;i<B_NUM;i++)for(j=0l;j<b_len[i];j++) /* call mltly_av() ??? */
        v->v[i][j]=M_d2f(M_f2d(v->v[i][j])*r);}
    return r;}

/* if blk==-1 save all blocks, idx>=0 index for name="d%d.vec" */
int savevec(tvec *v,const char *nam,int idx,int blk){
    FILE *f;ULong n2;int i=0;char s1[128],*s2;
    if(idx>=0) i=snprintf(s2=s1,128,nam,idx); else s2=(char *)nam;
    if(i<0) E0("file name to long");
    if(vvv&1)printf(" save_v %s",s2);
    if(!(f=fopen(s2,"wb")) ){ E1("fopen(%s)",s2);return 1;}
    for(i=((blk<0)?0:blk);i<((blk<0)?B_NUM:blk+1);i++){
      if(b_len[i]==0) continue;
      if(!v->v[i]){ E1(" failed, v[%d]==0",i); return 3;}
      if(blk>=0)if(fseek(f,(long)b_ofs[blk],SEEK_SET))E0("fseek");
      n2=fwrite((void *)v->v[i],Csize,(size_t)b_len[i],f);
      if( n2!=b_len[i] ){ E0("fwrite");return 2; }
    } fclose(f);return 0;}
int loadvec(tvec *v,const char *nam,int idx,int blk){
    FILE *f;ULong n2;int i=0;char s1[128],*s2;
    if(idx>=0) i=snprintf(s2=s1,128,nam,idx); else s2=(char *)nam;
    if(i<0) E0("file name to long");
    if(vvv&1)printf(" load_v %s",s2);
    if(!(f=fopen(s2,"rb")) ){ E0("fopen");return 1;}
    for(i=((blk<0)?0:blk);i<((blk<0)?B_NUM:blk+1);i++){
      if(b_len[i]==0) continue;
      if(!v->v[i]){ E1(" failed, v[%d]==0",i); return 3;}
      if(blk>=0)if(fseek(f,(long)b_ofs[blk],SEEK_SET))E0("fseek");
      n2=fread((void *)v->v[i],Csize,(size_t)b_len[i],f);
      if( n2!=b_len[i] ){ E0("fread");return 2; }
    } fclose(f);return 0;}
#if code2
int loadvec2(tvec *v,const char *nam, int idx){  /* lade vec von textfile */
    FILE *f;double r;ULong j;tbase i;int k,l,ret,blk;char buf[255];
    int ii=0; char s1[128],*s2;
    if(idx>=0) ii=snprintf(s2=s1,128,nam,idx); else s2=(cahr *)nam;
    if(ii<0) E0("file name to long");
    if(!v){ printf(" failed, v==NULL"); return 3;}
    if(!(f=fopen(s2,"rt"))){E1("loadvec_fopen(%s)",s2);return 1;}
    clrvec(v);ret=1;
    while(!feof(f)){
        if(!fgets(buf,255,f))break; /* zeile lesen: 0.25 |ud.3u> /n */
        if(sscanf(buf,"%lf",&r)!=1)continue;
        for(k=0;buf[k];k++) if(buf[k]=='|')break;
        i=CM((tbase1)0,((tbase){0,0}),((tbase){0,0}));j=0l;
        l=nn-1;
        if(buf[k]=='|'){
           for(k++;buf[k]!=0 && l>=0;k++)
#if CM(1,0,0)            
           if(buf[k]=='.'){F0("only u and d!");l--;} else
           if(buf[k]=='u'){         l--;} else
           if(buf[k]=='d'){i|=1l<<l;l--;} else
           if(buf[k]=='3'){F0("only u and d!");l--;} else
#else
           if(buf[k]=='.'){           l--;} else
           if(buf[k]=='u'){i.u|=1l<<l;l--;} else
           if(buf[k]=='d'){i.d|=1l<<l;l--;} else
           if(buf[k]=='3'){i.u|=1l<<l;i.d|=1l<<l;l--;} else
#endif
           E0("unknown symbol (not .ud3)"); }
        else E1("no konfig |xxxx> found in %s",nam);   
        j=lin(i); blk=b_getnum(j);
        if(vvv)printf("\n read: %6.3f |%s> => %ld",r,ckfg(i),j);
        v->v[blk][j-b_ofs[blk]]=M_d2f(r);ret=0;
      }
    fclose(f);return ret;}
#else
int loadvec2(tvec *v,const char *nam,int idx){         /* lade vec von textfile */
    FILE *f;double r;ULong j;tbase i;int k,l,blk,ret;char buf[255];
    int ii=0; char s1[128],*s2;
    if(idx>=0) ii=snprintf(s2=s1,128,nam,idx); else s2=(char *)nam;
    if(ii<0) E0("file name to long");
    if(!v){ printf(" failed, v==NULL"); return 3;}
    if(!(f=fopen(s2,"rt"))){E1("loadvec_fopen(%s)",s2);return 1;}
    clrvec(v);ret=1;
    while(!feof(f)){
        if(!fgets(buf,255,f))break; /* zeile lesen: 0.25 |ud.3u> /n */
        if(sscanf(buf,"%lf",&r)!=1)continue;
        for(k=0;buf[k];k++) if(buf[k]=='|')break;
        i=0l;j=0l;l=2*(nn-1) CM(/2,+0,+0);
        if(buf[k]=='|'){
           for(k++;buf[k]!=0 && l>=0;k++,CM(l--,l-=2,l-=2))	/* Apr99 */
           if(buf[k]=='.'){                   } else
           if(buf[k]=='u'){i|=CM(0l,1l,1l)<<l;} else
           if(buf[k]=='d'){i|=CM(1l,2l,2l)<<l;} else
           if(buf[k]=='3'){i|=         3l <<l;} else
           E0("unknown symbol (not .ud3)"); }
        else E1("no konfig |xxxx> found in %s",nam);   
        j=lin(i); blk=b_getnum(j);   
        if(vvv)printf("\n read: %6.3f |%s> => %ld",r,ckfg(i),j);
        v->v[blk][j-b_ofs[blk]]=M_d2f(r);ret=0;}
    fclose(f);return ret;}
#endif
   
#ifndef RAND_MAX
#define RAND_MAX 0x7fff
#endif
extern int startvec;
/* --- last change: 7.12.98 JS bug! --- 
 *  sum v[] during setting for faster normalization???
 */
void randvec(tvec *v,int ini){
    static thbuf *hbuf=NULL; double ee,emin=9e6; int en=0;
    ULong i; int blk; static int rnd=0;
    if(vvv) printf(" randvec%d-%d",startvec,ini);
    if(startvec==1){ clrvec(v);blk=b_getnum(ini-1l);
      v->v[blk][(ULong)ini-1l-b_ofs[blk]]=M_d2f(1); } else
    if(startvec==2){ loadvec(v,FileGS,ini,-1); } else
    if(startvec==3){ loadvec2(v,FileSV,ini); } else
    if(startvec==5){
      printf(" Ising");  /* best for algo==2 ??? */
      if(!hbuf)hbuf=alloc_hbuf();
      for(blk=0;blk<B_NUM;blk++) for(i=0l;i<b_len[blk];i++){
        ee=D(hamilton_nhv(b_ofs[blk]+i,NULL,hbuf,1));
        /* <n|Hn> Diagonal-H von |n> */
        if(ee< emin) { emin=ee; en=0; }
        if(ee==emin) en++;
      }
      printf(" emin=%g EA=%d",emin,en);
      for(blk=0;blk<B_NUM;blk++) for(i=0l;i<b_len[blk];i++){
        ee=D(hamilton_nhv(b_ofs[blk]+i,NULL,hbuf,1));
         /* <n|Hn> Diagonal-H von |n> */
        v->v[blk][i]=M_d2f( ((ee==emin)?1:0) );
        if (ee==emin) {blk=B_NUM;break;}
      }
    } else
    if(startvec>4){ printf(" no startvec"); } else
    { if(startvec==4){ srand(rnd);rnd++; } 
      else             srand(ini);
      for(blk=0;blk<B_NUM;blk++) for(i=0l;i<b_len[blk];i++)
        v->v[blk][i]=M_d2f((3 & rand())*0.25); /* Jul00 */
      v->v[0][0]=M_d2f(0.5);	/* be sure v is never zero */
    }
    normvec(v); return;
}
    
cplx sprod(tvec *a, tvec *b){ /* Skalarprodukt REIHENFOLGE!!!! */
    cplx r=0.0;ULong i;int blk;
    for(blk=0;blk<B_NUM;blk++)
    for(i=0l;i<b_len[blk];i++)r+=Conj(M_f2d(a->v[blk][i])) * M_f2d(b->v[blk][i]);
    return(r); }
int  iortho(tvec *v0, tvec *v1){ /* 0=ok,1=parallel */
    cplx r1;zahl r2;ULong i;int blk;
    r1=sprod(v0,v1);
 /* if(fabs(r1)>0.99999){printf(" iortho: v0=v1 ");return(1);} */
    if(fabs(r1)<1.0e-20){return(0);}
    r2=0.0;
    for(blk=0;blk<B_NUM;blk++)for(i=0l;i<b_len[blk];i++){
      v0->v[blk][i]-=M_d2f(r1*M_f2d(v1->v[blk][i])); /* round error ??? */
      r2+=Norm(M_f2d(v0->v[blk][i]));
    }
    if(fabs(r1)>0.99999){printf(" iortho: v0=v1");return(1);}
    r2=1.0/sqrt(r2);
    for(blk=0;blk<B_NUM;blk++)for(i=0l;i<b_len[blk];i++)
      v0->v[blk][i]=M_d2f(M_f2d(v0->v[blk][i])*r2);  /* call mltly_av ??? */
    return(0); }

