#! /bin/sh
# generate new daten.def (spin-1) from old daten.def (spin-1/2)  
#  by Joerg.Schulenburg@physik.uni-magdeburg.de Feb99
#
# see /usr/doc/info/gawk.info.gz
#
version="v0.2 Jan00"
#
ns=5
# ns=2 doubles spin length, ns=3 triples spin length
# 1. Argument ist Dateiname des def-files
#
if test -z "$1"; then file=daten.def
                 else file=$1
fi
if test ! -r $file; then echo "file $file not found";exit; fi
echo "# this file was automaticly generated by defspin1.sh ${version}"
#
#
awk -v ns=$ns '\
  function outs( x, y, s, c) 
  { printf "4 0 0 18 0 %d 0.00000 4 17 12 %d %d %d\001\n",c,x+10,y+7,s }
  function outc( x, y, s, c) 
  { printf "4 0 0 18 0 %d 0.00000 4 17 12 %d %d %s\001\n",c,x+10,y+7,s }
  BEGIN {\
     printf "# enlarge S by factor %d\n",ns;
     count=0;nr=0;b1x=1;b1y=0;b2x=0;b2y=-1;e1x=0;e1y=0;e2x=0;e2y=0;
  }
  !/^\#/ { count++; nr=count; }
  /^\#/  { nr=0; printf "%s\n",$0 }
  (nr == 1) { vn=$1;vnw=$2; printf "# ns=%d NN=ns*%d Nw=ns*ns*%d\n%d %d 0\n",ns,vn,vnw,ns*vn,ns*ns*vnw }
  (nr > 1) && (nr < vn+2) {\
       ax[$1]=$2; ay[$1]=$3; az[$1]=$4; ae[$1]=$5; aU[$1]=$6;
  }
  (nr == vn+1){\
       for(j=0;j<ns;j++)for(i=0;i<vn;i++)\
       printf "%3d %2d %2d %2d %2d %2d\n",i+j*vn,ax[i],ay[i],az[i],ae[i],aU[i];
  }
  (nr > vn+1) {\
#       if (match($0,"+"))
       b1[$1]=$2; b2[$1]=$3; bt[$1]=$4; bJ[$1]=$5; bV[$1]=$6;
  }
  (nr == vn+1+vnw){\
       for(j1=0;j1<ns;j1++)for(j2=0;j2<ns;j2++)for(i=0;i<vnw;i++)\
       printf "%3d %2d %2d %2s %2s %2s\n",i+(j1*ns+j2)*vnw,j1*vn+b1[i],j2*vn+b2[i],bt[i],bJ[i],bV[i];
  }
  ' $file
exit

